/*
 * dllmem.h - Copyright (c) 1995, 1996 by Tony Toole.
 * DLLPower v2.51 header.
 * Include this header once per DLL and EXE, this sets up the new memory
 * functions.
 * You will get some warnings linking your application, just ignore, harmless.
 */

#ifndef DLLPMEM_H
  #define DLLPMEM_H
  #include <stdio.h>

  #ifdef __cplusplus
  extern "C"
  {
  #endif

    /*
     * Overload the malloc, calloc and free, read the doc to find out why.
     */
    void *PowerMalloc(size_t s);
    void *PowerCalloc(size_t s1, size_t s2);
    void  PowerFree(void *s);

    void *malloc(size_t s)
    {
      return PowerMalloc(s);
    }

    void *calloc(size_t s1, size_t s2)
    {
      return PowerCalloc(s1, s2);
    }

    void free(void *s)
    {
      PowerFree(s);
    }
  #ifdef __cplusplus
  }
  #endif
#endif
