#include <stdio.h>
#include <stdlib.h>
#include "stuff.h"

extern "C" int DoExit(int);

long FileSize(FILE *stream)
{
  long curpos, length;

  curpos = ftell(stream);
  fseek(stream, 0L, SEEK_END);
  length = ftell(stream);
  fseek(stream, curpos, SEEK_SET);
  return length;
}

unsigned short Magic;
int main(int argc, char *argv[])
{
  FILE *ap;
  DOSHDR DosHdr;
  int HeaderPos;

  printf("PEFIX v2.50, Copyright(c) 1995, 1996 by Tony Toole.\n");
  if(argc != 2)
  {
    printf("[PEFIX]: Syntax is PEFIX <executable.exe>\n");
    exit(1);
  }

  if((ap = fopen(argv[1], "rb+")) == NULL)
  {
    printf("[PEFIX]: Error loading %s\n", argv[1]);
    exit(2);
  }

  fread(&DosHdr,sizeof(DosHdr), 1, ap);
  if(DosHdr.Magic[0] == 'Z' && DosHdr.Magic[1] == 'M')
  {
    printf("[PEFIX]: This is not an executable.\n");
    exit(5);
  }
  if (fseek(ap, DosHdr.NewExePtr, SEEK_SET) != 0)
  {
    printf("[PEFIX]: The dos exe header is corrupt.\n");
    exit(3);
  }   

  HeaderPos = ftell(ap);
  fread(&Magic, sizeof(short), 1, ap);
  fseek(ap, HeaderPos, SEEK_SET);
  if(Magic != PE_MAGIC)
  {
    printf("[PEFIX]: This is not a valid PE file\n");
    exit(6);
  }
  Magic = PL_MAGIC; // Change from PE to PL
  fwrite(&Magic, sizeof(short), 1, ap);
  fclose(ap);
  printf("You are now able to execute %s under Windows 95\n", argv[1]);
  return 0;
}





