//  jsmouse.h
//
//  Copyright 1995, Jeffrey A. Schierenbeck
//


#ifndef JSMOUSE
#define JSMOUSE

const int LEFT = 0;   // for button calls
const int RIGHT = 1;   //

class Mouse
	{private:
		int exists,
		    enabled,
		    visible,
		    xpos, ypos;
	 public:
		Mouse(void);
		int Exists(void)  {return exists;};
		int Enabled(void) {return enabled;};
		int Visible(void) {return visible;};
		void Show(void);
		void Hide(void);
		int TimesPressed(int);
		int x(void)  {return xpos;};
		int y(void)  {return ypos;};
		void GetPosition(void);
		void LocateAt(int x, int y);
		int InBox(int l, int t, int r, int b);
		int ButtonDown(int but);
		void SetxLimits(int min, int max);
		void SetyLimits(int min, int max);
		int GetPage(void);
		void SetPage(int newpage);
void set_sub(int mask, void interrupt (*handler)(void));
	};
extern Mouse mouse;

#endif

// End jsmouse.h