#include <l_list.hpp>
#include <lottlist.hpp>
#include <stdio.h>
void Lot_draw::printer(void)
{
	printf("*********************************************************\n");
	printf("If you had chosen ");
	printf("%2d %2d %2d %2d %2d %2d on %ld you'd be rich!\n",number[0],
		number[1],number[2],number[3],number[4],number[5],key);
	printf("*********************************************************\n");
}
/************************************************************************
	all that delete_data() has to do is cast the pointer properly
************************************************************************/
void Lot_list::delete_data(void *draw)
{
	delete (Lot_draw *) draw;
}
/************************************************************************
	You can overload the locate function in the derived class.  You will
	have to declare the parent class function to avoid linker errors.
	This works fine with Turbo C++, if your compiler isn't as thorough in
	its type checking you may have to write a my_locate() function in the
   derived class.
************************************************************************/
int Lot_list::locate(void *key,int (comp)(void *std,void *loc))
{
	return l_list::locate(key,(comp));
}
/************************************************************************
	This locate function was cloned from the l_list::locate function, it
	is less cumbersome to use than the one expecting void pointers to
	objects.
************************************************************************/
int Lot_list::locate(long locate_key,int(*comp)(void*,long locate_key))
{
int ins_test;
ll_element *beginning;
ll_element *ending;
	beginning = head->prev;	//these are set to the start and finish
	ending = head->next;		//of the list
	ins_test = comp(beginning->data,locate_key);
	if(ins_test > 0)
		{// the key is less than any in the list
		cursor = head->prev;
		return 0;
		}
	else
		{
		if(ins_test == 0)
			{
			cursor = beginning;
			return 1;
			}
		}
	ins_test = comp(ending->data,locate_key);
	if(ins_test == 0)
		{
		cursor = head->next;
		return 1;
		}
	if(ins_test < 0)
		{// the key is greater than any in the list
		cursor = head->next;
		return 0;
		}
	ins_test = -1;
	reset();
	while(ins_test <= 0)
		{//advance the cursor until the cursor is greater than the insert rec
		ins_test = comp(cursor->data,locate_key);
		if(ins_test == 0)
			return 1;
		else
			{
			if(cursor->next)
				cursor = cursor->next;
			else
				break;
			}
		}
	return 0;
}
